using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace GridException
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            DataTable dt1 = new DataTable("Test 1");
            DataColumn col1A = new DataColumn("A");
            col1A.AllowDBNull = false;
            col1A.DataType = typeof(double);
            DataColumn col1B = new DataColumn("B");
            col1B.AllowDBNull = false;
            DataColumn col1C = new DataColumn("C");
            col1C.AllowDBNull = false;

            DataTable dt2 = new DataTable("Test 2");
            DataColumn col2A = new DataColumn("A");
            col2A.AllowDBNull = false;
            DataColumn col2B = new DataColumn("B");
            col2B.AllowDBNull = false;
            DataColumn col2C = new DataColumn("C");
            col2C.AllowDBNull = false;
            DataColumn col2D = new DataColumn("D");
            col2D.AllowDBNull = false;

            DataTable dt3 = new DataTable("Test 3");
            DataColumn col3A = new DataColumn("A");
            col3A.AllowDBNull = false;
            DataColumn col3B = new DataColumn("B");
            col3B.AllowDBNull = false;
            DataColumn col3C = new DataColumn("C");
            col3C.AllowDBNull = false;
            DataColumn col3D = new DataColumn("D");
            col3D.AllowDBNull = false;



            dt1.Columns.Add(col1A);
            dt1.Columns.Add(col1B);
            dt1.Columns.Add(col1C);

            for (int i = 0; i <= 12; i++)
            {
                DataRow newRow = dt1.NewRow();
                newRow["A"] = i;
                newRow["B"] = "Example";
                newRow["C"] = "Hansi";
                dt1.Rows.Add(newRow);
            }

            dt2.Columns.Add(col2A);
            dt2.Columns.Add(col2B);
            dt2.Columns.Add(col2C);
            dt2.Columns.Add(col2D);

            dt3.Columns.Add(col3A);
            dt3.Columns.Add(col3B);
            dt3.Columns.Add(col3C);
            dt3.Columns.Add(col3D);

            DataSet myDS = new DataSet();
            //myDS.Tables.AddRange(new DataTable[] { dt1 });
            //myDS.Tables.AddRange(new DataTable[] { dt1, dt2, dt3 });
            myDS.Tables.AddRange(new DataTable[] { dt1, dt2 });


            gridGroupingControl1.DataSource = myDS;

			this.gridGroupingControl1.TableControlCurrentCellControlKeyMessage += new GridTableControlCurrentCellControlKeyMessageEventHandler(gridGroupingControl1_TableControlCurrentCellControlKeyMessage);
			this.gridGroupingControl1.CurrentRecordContextChange += new Syncfusion.Grouping.CurrentRecordContextChangeEventHandler(gridGroupingControl1_CurrentRecordContextChange);
			this.gridGroupingControl1.TableControlCurrentCellKeyDown += new GridTableControlKeyEventHandler(gridGroupingControl1_TableControlCurrentCellKeyDown);
            this.gridGroupingControl1.TableControlCurrentCellValidating += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellValidating);
            //this.gridGroupingControl1.TableControlCurrentCellMoveFailed += new GridTableControlCurrentCellMoveFailedEventHandler(gridGroupingControl1_TableControlCurrentCellMoveFailed);
            this.gridGroupingControl1.TableControlCurrentCellConfirmChangesFailed += new GridTableControlEventHandler(gridGroupingControl1_TableControlCurrentCellConfirmChangesFailed);
        }

        void gridGroupingControl1_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
        {
            if (!validationAlreadyCalled)
            {
                GridCurrentCell cc = e.TableControl.CurrentCell;
                GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);
                GridColumnDescriptor cd = style.TableCellIdentity.Column;

                string ll = e.TableControl.CurrentCell.Renderer.ControlText;
                string tableName = e.TableControl.TableDescriptor.Name;

                DataTable actTable = (gridGroupingControl1.DataSource as DataSet).Tables[tableName];
                Type actType = actTable.Columns[cd.Name].DataType;
                try
                {
                    Convert.ChangeType(ll, actType);
                }
                catch (Exception)
                {
                    MessageBox.Show("Wrong value for that type","Validating");
                    e.Inner.Cancel = true;
                    e.TableControl.CurrentCell.ErrorMessage = "";
                }
            }
            validationAlreadyCalled = false;

        }

        private bool validationAlreadyCalled = false;

        void gridGroupingControl1_TableControlCurrentCellKeyDown(object sender, GridTableControlKeyEventArgs e)
        {
            validationAlreadyCalled = false;
            if (e.Inner.KeyCode == Keys.Up || e.Inner.KeyCode == Keys.Down)
            {
                GridCurrentCell cc = e.TableControl.CurrentCell;
                GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);
                Element rec = style.TableCellIdentity.DisplayElement;
                if (rec != null)
                {
                    DataRowView drv = rec.GetData() as DataRowView;
                    validationAlreadyCalled = drv != null;
                    string field = "";
                    if (drv != null && cc.ConfirmChanges() && !this.ValidateDataRow(drv.Row, out field))
                    {
                        e.Inner.Handled = true;
                        if (rec is AddNewRecord)
                        {
                            ((AddNewRecord)rec).SetCurrent(field);
                        }
                        else if (rec is GridRecord)
                        {
                            ((GridRecord)rec).SetCurrent(field);
                        }
                    }

                }
            }
        }

        void gridGroupingControl1_TableControlCurrentCellConfirmChangesFailed(object sender, GridTableControlEventArgs e)
        {
            bool isValid = e.TableControl.CurrentCell.IsValid;
        }

		void gridGroupingControl1_TableControlCurrentCellControlKeyMessage(object sender, GridTableControlCurrentCellControlKeyMessageEventArgs e)
		{
			Keys keyCode = (Keys)((int)e.Inner.Msg.WParam) & Keys.KeyCode;
			if (keyCode == Keys.Enter)
			{
				if (e.Inner.Msg.Msg == 0x100) //KEYDOWN
				{
					SendKeys.Send("{TAB}");
                    //Console.WriteLine("Send Tab");
				}
				e.Inner.Handled = true;
			}
			
		}
		
		void gridGroupingControl1_CurrentRecordContextChange(object sender, Syncfusion.Grouping.CurrentRecordContextChangeEventArgs e)
		{
            //Console.WriteLine(e.Action);
			if (e.Action == CurrentRecordAction.EndEditCalled && e.Record != null)
			{
                //Console.WriteLine("------------------- ContextChanged -------------------");
				string field = "";
				DataRowView drv = (e.Record != null) ? e.Record.GetData() as DataRowView : null;
				if (drv != null && !ValidateDataRow(drv.Row, out field))
				{
					e.Cancel = true;

					if (e.Record is AddNewRecord)
					{
						((AddNewRecord)e.Record).SetCurrent(field);
					}
					else if (e.Record is GridRecord)
					{
						((GridRecord)e.Record).SetCurrent(field);
					}
				}
				
			}
		}

        private bool ValidateDataRow(DataRow dr, out string field)
        {
            //Console.WriteLine("------------ Call ValidateDataRow ------------------");
            field = "";
            bool b = true;

            DataTable dt = dr.Table;
            foreach (DataColumn dc in dt.Columns)
            {
                if (!dc.AllowDBNull && (dr[dc] == null || dr[dc] == DBNull.Value
                    || dr[dc] as string == string.Empty))
                {
                    b = false;
                    field = dc.ColumnName;
                    //MessageBox.Show(string.Format("nulls not allowed in {0}", field));
                    MessageBox.Show(string.Format("Please enter a correct value for the column '{0}'", field),"Validate Row");
                    break;
                }
            }
            return b;

        }

        private void gridGroupingControl1_TableControlCurrentCellMoveFailed(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCurrentCellMoveFailedEventArgs e)
        {
                //Console.WriteLine(e.TableControl.TableDescriptor.Name);
                GridCurrentCell cc = e.TableControl.CurrentCell;
                GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(cc.RowIndex, cc.ColIndex);
                GridColumnDescriptor cd = style.TableCellIdentity.Column;

                string ll = e.TableControl.CurrentCell.Renderer.ControlText;
                string tableName = e.TableControl.TableDescriptor.Name;

                DataTable actTable = (gridGroupingControl1.DataSource as DataSet).Tables[tableName];
                Type actType = actTable.Columns[cd.Name].DataType;
                try
                {
                    Convert.ChangeType(ll, actType);
                }
                catch (Exception err)
                {
                    MessageBox.Show("Wrong value for that type");
                    e.TableControl.CurrentCell.ErrorMessage = "";
                    //e.Inner.Cancel = true;
                }


                //e.TableControl.CurrentCell.Lock();
                //MessageBox.Show("Invalid Datatype,Cannot Move");
                //e.TableControl.CurrentCell.Unlock();
                //e.TableControl.CurrentCell.ErrorMessage = "";
        }
    }
}